import unittest
from sys import path
path.append('/usr/lib/zope/lib/python/Products')
from IcubeZTester.zopetester import zopetester

class basicTestCase(unittest.TestCase):

    def setUp(self):
        self.zt = zopetester('nome')

    def tearDown(self):
        del self.zt

    def testPass(self):
        pass

    def testBasics(self):
        assert self.zt._skip_pass == 1
        assert self.zt._remote_tests == []
        assert self.zt.title == ''
        assert  self.zt.id == 'nome'

    def testRunScriptPass(self):
        def script():
            pass
        result = self.zt.runScript(script)
        assert result == ('pass', '', '', []), result

    def testRunScriptFail(self):
        def script():
            assert 1==2, "assertion string"
        result = self.zt.runScript(script)
        assert result[0] == 'fail', result
        assert len(result) == 4, result

    def testRunScriptError(self):
        def script():
            thisShouldBeAnError
        result = self.zt.runScript(script)
        assert result[0] == 'error', result
        assert len(result) == 4, result

    def testColorCode(self):
        assert self.zt.colorCode('pass') == '#66DD66'
        assert self.zt.colorCode('fail') == '#DDDD66'
        assert self.zt.colorCode('error') == '#DD6666'

    def testAddRemoteTest(self):
        assert len(self.zt._remote_tests) == 0, self.zt._remote_tests
        self.zt.addRemoteTest('one/two')
        assert len(self.zt._remote_tests) == 1, self.zt._remote_tests
        assert self.zt._remote_tests[0] == 'one/two', self.zt._remote_tests

    def testGetSetRemoteTests(self):
        assert self.zt.getRemoteTests() == [], self.zt.getRemoteTests()
        self.zt.setRemoteTests(['one/two'])
        assert self.zt.getRemoteTests() == ['one/two'], self.zt.getRemoteTests()

    def testSetSkipPass(self):
        assert self.zt.setSkipPass
        self.zt.setSkipPass(0)
        assert self.zt._skip_pass == 0

    def testGetSkipPass(self):
        assert self.zt.getSkipPass
        self.zt._skip_pass == 1
        assert self.zt.getSkipPass() == 1
        del self.zt._skip_pass
        assert self.zt.getSkipPass() == 1
        assert hasattr(self.zt, '_skip_pass')
